require "TimedActions/ISReadABook"

local MIN_LIGHT = 127
--[[ light in room (without windows, door is closed, no light-source)
					01:00	13:00
with NightVision	48		99
no NightVision		35		103
]]

local function getPlayerLight(Player)
	local player_id = Player:getPlayerNum()
	local square = Player:getCurrentSquare()
	local colors = {
		square:getVertLight(0, player_id),
		square:getVertLight(1, player_id),
		square:getVertLight(2, player_id),
		square:getVertLight(3, player_id),
		square:getVertLight(4, player_id),
		square:getVertLight(5, player_id),
		square:getVertLight(6, player_id),
		square:getVertLight(7, player_id),
	}
	local light = 0
	
	for i, color in ipairs(colors) do
		local hex_str = string.format("%x", color) -- "ffa1b2c3"
		light = math.max(
			tonumber(string.sub(hex_str, 3, 4), 16) or 0, -- "a1"
			tonumber(string.sub(hex_str, 5, 6), 16) or 0, -- "b2"
			tonumber(string.sub(hex_str, 7, 8), 16) or 0, -- "c3"
			light
		)
	end
	
	return light
end


local default_update = ISReadABook.update

function ISReadABook:update()
	local light = getPlayerLight(self.character)
	if light < MIN_LIGHT then
		local vehicle = self.character:getVehicle()
		if vehicle == nil or (vehicle ~= nil and vehicle:getBatteryCharge() <= 0) then -- no car or car without energy
			-- print(string.format("NRK: NeedLightToRead [%d < %d]", light, MIN_LIGHT))
			self.character:Say(getText("IGUI_NRK_NeedLightToRead"))
			self:forceStop()
		end
	end
	
	default_update(self)
end
